-- toggle in the nearby ships list that temporary locks the list
-- clicking on anything unlocks it

local function modify_nearbytab(tab)
	local gnc = iup.GetNextChild
	local gb = iup.GetBrother

	local lockcontrol
	
	local locked = false

	local box = gnc(gb(gb(gnc(tab))))
	local matrix = gnc(tab)
	

	local function lock()
		locked = true
		lockcontrol.value = "on"
		lockcontrol.fgcolor = "200 0 0"
	end
	
	local function unlock()
		locked = false
		lockcontrol.value = "off"
		lockcontrol.fgcolor = tabunseltextcolor
		ProcessEvent("UPDATE_CHARINFO", GetCharacterID())
	end

	lockcontrol = iup.stationtoggle{title="Lock", value="off"}
	function lockcontrol:action(state)
		if state == 1 then
			lock()
		else
			unlock()
		end
	end
	iup.Append(box, lockcontrol)


	local update_old = matrix.update
	function matrix:update()
		if not locked then
			return update_old(matrix)
		end
	end

	local click_cb_old = matrix.click_cb
	function matrix:click_cb(row, column)
		if locked then
			unlock()
		end
		return click_cb_old(matrix, row, column)
	end

	local OnEvent_old = tab.OnEvent
	function tab:OnEvent(...)
		if not locked then
			return OnEvent_old(tab, ...)
		end
	end

	local OnShow_old = tab.OnShow
	function tab:OnShow()
		unlock()
		OnShow_old(tab)
	end
end

modify_nearbytab(StationPDASensorNearbyTab)
modify_nearbytab(PDASensorNearbyTab)
modify_nearbytab(CapShipPDASensorNearbyTab)
